using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;

namespace csimap4
{
    public partial class FormProperty : Form
    {
        public FormProperty()
        {
            InitializeComponent();
        }

        private void FormProperty_Load(object sender, EventArgs e)
        {
			for(int no = 0 ; no < PathList.Count ; no++) {
            	AddTree((string)PathList[no], (string)TextList[no]);
			}
			if(treeMime.TopNode != null)
			{
				treeMime.TopNode.Expand();
			}
        }

		private ArrayList PathList = new ArrayList();
		private ArrayList TextList = new ArrayList();

		private TreeNode SearchNode(TreeNode node, string path)
		{
			if(node != null)
			{
				foreach(TreeNode tn in node.Nodes)
				{
					TreeNode ctn;
					if((ctn = SearchNode(tn, path)) != null)
					{
						return ctn;
					}
					if(tn.Tag != null) 
					{
						string data = (string)tn.Tag;
						if(string.Compare(data, path, true) == 0)
						{
							return tn;
						}
					}
				}
			}
			return null;
		}

		private void AddTree(string name, string text)
		{
			int no;
			TreeNode node, parent_node;
			string path;
			string [] folder = name.Split('.');

			parent_node = treeMime.TopNode;
			treeMime.PathSeparator = ".";
			for(no = 0 ; no < folder.Length ; no++)
			{
				path = string.Join(".", folder, 0, no + 1);
				node = SearchNode(treeMime.TopNode, path);
				if(node == null)
				{
					node = new TreeNode(text);
					node.Tag = name;
					if(parent_node == null)
					{
						treeMime.Nodes.Add(node);
					}
					else
					{
						parent_node.Nodes.Add(node);
						parent_node.Expand();
					}
				}
				parent_node = node;
			}
		}

		public void AddTreeItem(string path, string text)
		{
			PathList.Add(path);
			TextList.Add(text);
		}

		public string Header
		{
			set
			{
				textHeader.Text = value;
			}
		}
    }
}