//---------------------------------------------------------------------------

#ifndef testmainH
#define testmainH
#include <System.Classes.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.ImgList.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.StdCtrls.hpp>
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TTreeView *MailBoxTree;
    TSplitter *Splitter1;
    TPanel *RightPanel;
    TListView *MailList;
    TSplitter *Splitter2;
    TListView *AttachList;
    TMemo *BodyMemo;
    TMainMenu *MainMenu;
    TMenuItem *F1;
    TMenuItem *CreateItem;
    TMenuItem *N1;
    TMenuItem *ExitItem;
    TMenuItem *O1;
    TMenuItem *OptionItem;
    TPopupMenu *MailBoxPopupMenu;
    TMenuItem *CreateMailBoxItem;
    TMenuItem *N2;
    TMenuItem *DeleteMailBoxItem;
    TMenuItem *N3;
    TMenuItem *RenameMailBoxItem;
    TPopupMenu *MailPopupMenu;
    TMenuItem *ReplyMailItem;
    TMenuItem *N4;
    TMenuItem *DeleteMailItem;
    TMenuItem *N5;
    TMenuItem *PropertyMailItem;
    TPopupMenu *AttachPopupMenu;
    TMenuItem *OpenAttachItem;
    TMenuItem *SaveAttachItem;
    TImageList *MailBoxImageList;
    TImageList *AttachImageList;
    TSaveDialog *SaveDialog;
    TTimer *NoopTimer;
	TMenuItem *RenewItem;
	TMenuItem *N6;
    void __fastcall MailBoxTreeChange(TObject *Sender, TTreeNode *Node);
    void __fastcall MailBoxTreeChanging(TObject *Sender, TTreeNode *Node,
          bool &AllowChange);
    void __fastcall MailBoxTreeDragDrop(TObject *Sender, TObject *Source,
          int X, int Y);
    void __fastcall MailBoxTreeDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
    void __fastcall MailBoxTreeEdited(TObject *Sender, TTreeNode *Node,
          String &S);
    void __fastcall MailBoxTreeEditing(TObject *Sender, TTreeNode *Node,
          bool &AllowEdit);
    void __fastcall MailListChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
    void __fastcall MailListEndDrag(TObject *Sender, TObject *Target,
          int X, int Y);
    void __fastcall MailListMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall MailListMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
    void __fastcall MailListMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall AttachListDblClick(TObject *Sender);
    void __fastcall CreateItemClick(TObject *Sender);
    void __fastcall ExitItemClick(TObject *Sender);
    void __fastcall OptionItemClick(TObject *Sender);
    void __fastcall CreateMailBoxItemClick(TObject *Sender);
    void __fastcall RenameMailBoxItemClick(TObject *Sender);
    void __fastcall DeleteMailBoxItemClick(TObject *Sender);
    void __fastcall ReplyMailItemClick(TObject *Sender);
    void __fastcall DeleteMailItemClick(TObject *Sender);
    void __fastcall PropertyMailItemClick(TObject *Sender);
    void __fastcall OpenAttachItemClick(TObject *Sender);
    void __fastcall SaveAttachItemClick(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormActivate(TObject *Sender);
    void __fastcall MailBoxTreeMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
    void __fastcall AttachListChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
    void __fastcall NoopTimerTimer(TObject *Sender);
	void __fastcall RenewItemClick(TObject *Sender);
private:	// [U[錾
    SOCKET Socket;       // \Pbg
    String Id;       // ID
    String Password; // pX[h
    String Imap4Name; // IMAP4T[o[
    int SmtpAuth; // SMTP F،`
    int SmtpSsl; // SMTP SSL
    int SmtpPort; // SMTP |[gԍ
    int Imap4Auth; // IMAP4 F،`
    int Imap4Ssl; // SMTP SSL
    int Imap4Port; // SMTP |[gԍ
    String MailBox; // I𒆂̃[{bNX
    String TrashMailBox; // S~
    String SentMailBox; // M
    int DragX, DragY;
    int TimerCount;
    bool DragFlag;
    void GetMailList();  // 薼ꗗListViewɕ\
    void MailListDataClear();
    bool Authenticate();
    bool CheckSetting();
    void GetMailBoxTree();
    void GetMail();
    void ChangeChildItemString(TTreeNode *node, String old_path, String new_path, bool flag);
    void OpenAttachFile();
    void AppendSent(String tostr, String subject, String body, String attach);
    bool DeleteChildMailBox(TTreeNode *node, bool flag);
public:		// [U[錾
    String SmtpName;    // SMTPT[o[
    String MailAddress; // [AhX
    __fastcall TMainForm(TComponent* Owner);
};

struct TMailData {
   DWORD Uid;			// [ UID
   int Flag;			// [bZ[WtO
   String Header;	// [wb_
};
struct TMailBoxData {
   String Path;		// [{bNXtpX
   String Separate;	// [{bNX
   int Flag;			// [{bNXtO
};

//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#define OPTION_SECTION          _T("BcbImap4")
#define OPTION_SMTP_NAME        _T("SmtpName")
#define OPTION_SMTP_AUTH        _T("SmtpAuth")
#define OPTION_SMTP_SSL         _T("SmtpSsl")
#define OPTION_SMTP_PORT        _T("SmtpPort")
#define OPTION_IMAP4_NAME       _T("Imap4Name")
#define OPTION_IMAP4_AUTH       _T("Imap4Auth")
#define OPTION_IMAP4_SSL        _T("Imap4Ssl")
#define OPTION_IMAP4_PORT       _T("Imap4Port")
#define OPTION_MAIL_ADDRESS     _T("MailAddress")

#define MailboxInbox _T("inbox")
#define MailboxTrash _T("trash")
#define MailboxSent  _T("sent")
#define MailboxTreeNameInbox _T("M")
#define MailboxTreeNameTrash _T("S~")
#define MailboxTreeNameSent  _T("M")

#define HEADER_MAX              8192
#define CONTINUE_TIMER_COUNT    (60*25)

enum {
	iconUser,
	iconInbox,
	iconSent,
	iconTrash,
	iconFolder,
	iconNoSelect
};
enum {
	columnAttach,
	columnSubject,
	columnFrom,
	columnDate
};

#endif
